<template>
  <div class="app-container">
    <!--筛选条件-->
    <div class="search-div">
      <el-form ref="selectForm" :inline="true" :model="listQuery" class="form-container">
        <el-row>
          <el-form-item class="selectForm-container-item" prop="keyword">
            <el-input v-model.trim="listQuery.cardCode" placeholder="卡编号" clearable/>
          </el-form-item>
          <el-form-item class="selectForm-container-item">
            <el-input v-model.trim="listQuery.personCode" placeholder="人员编号" clearable/>
          </el-form-item>
          <el-button class="filter-item" type="primary" icon="el-icon-search" @click="search">搜索</el-button>
        </el-row>
      </el-form>
    </div>
    <!--查询结果Table显示-->
    <div>
      <el-row class="table-title">
        <el-col :span="6"><div class="title-header"><i class="el-icon-menu"/>卡片列表</div></el-col>
        <el-col :span="12" :offset="6" class="edit_btns">
          <el-button class="edit_btn" size="small" @click="del">删除</el-button>
          <el-button class="edit_btn" size="small" @click="add">新增</el-button>
          <el-upload
            :limit="1"
            :show-file-list="false"
            :http-request="uploadFile"
            :file-list="fileList"
            action="string"
            accept=".xls,.xlsx"
            class="edit_btn"
            style="margin-top: 0">
            <el-button slot="trigger" class="edit_btn" size="small">批量导入</el-button>
          </el-upload>
          <download-template ref="downloadTemplate" :filename="filename" />
          <el-button :disabled="total===0" class="edit_btn" size="small" @click="batchExport">导出记录</el-button>
        </el-col>
      </el-row>
      <el-table v-loading="listLoading" :data="list" class="table" border @selection-change="handleSelectionChange">
        <el-table-column v-if="hasPerm('/device/delete')" align="center" type="selection" width="55"/>
        <el-table-column :index="indexMethod" align="center" type="index" label="序号" width="55"/>
        <el-table-column v-for="column in columns" :key="column.value" :label="column.text" :width="column.width" :align="column.align" show-overflow-tooltip>
          <template slot-scope="scope">
            <span v-if="column.type!='Button'" :class="column.class">{{ scope.row[column.value] }}</span>
            <el-button v-if="column.type=='Button'" type="text" @click="showWellDetail(scope.row)">{{ scope.row[column.value] }}</el-button>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="160">
          <template slot-scope="scope">
            <el-button v-if="hasPerm('/device/update')" type="text" @click="edit(scope.row)">编辑</el-button>
            <!--<el-button type="text" @click="log(scope.row)">刷卡记录</el-button>-->
            <!--<el-button v-if="hasPerm('/device/update')" type="text" @click="del(scope.row)">删除</el-button>-->
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!--分页-->
    <div class="pagination-container">
      <el-pagination
        v-show="total>listQuery.limit"
        :current-page="listQuery.offset"
        :page-sizes="[20,30,50,100]"
        :page-size="listQuery.limit"
        :total="total"
        align="center"
        layout="total, sizes, prev, pager, next"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"/>
    </div>
    <edit-card v-show="editShow" ref="editcard" @watchChild="fetchData"/>
    <!--<card-record v-show="cardRecord" ref="cardrecord" @watchChild="fetchData"/>-->
  </div>
</template>

<script>
import editCard from '@/views/cardManage/editCard'
import selectTree from '@/components/SelectTree/singleSelect'
import { getCardList, batchImportCard, batchExportCard, delCard } from '@/api/card'
import DownloadTemplate from '@/components/DownloadTemplate'
import DeptSelect from '@/components/DeptSelect/index'
import { downloadFile } from '@/utils/downloadUtils'
// import CardRecord from './cardRecord'
export default {
  name: 'ListCard',
  components: { DeptSelect, DownloadTemplate, editCard, selectTree },
  data() {
    return {
      listQuery: {
        cardCode: '',
        personCode: '',
        offset: 1,
        limit: 20,
        // sort: 'id',
        // order: 'asc'
      }, // 筛选条件
      columns: [
        {
          text: '员工编号',
          value: 'personCode',
          align: 'center'
        },
        {
          text: '员工姓名',
          value: 'personName',
          align: 'center',
        },
        {
          text: '卡编号',
          value: 'cardCode',
          align: 'center'
        },
        {
          text: '单位/部门',
          value: 'deptName',
          align: 'center'
        },
        {
          text: '卡状态',
          value: 'STATUS',
          align: 'center'
        }
      ], // 显示列
      multipleSelection: [], // 多选选中项
      list: [], // 列表数据
      total: 0, // 数据总数
      deviceTypeList: [], // 设备类型列表
      deptProps: {
        parent: 'pid',
        value: 'id',
        label: 'name',
        children: 'children'
      }, // 权属单位树形下拉菜单
      deptTreeList: null, // 组织树列表数据
      showDeptTree: 0, // 是否显示权属单位下拉
      showDeviceType: true, // 是否显示设备类型下拉
      fileList: [],
      listLoading: true, // 加载动画
      fullscreenLoading: false, // 全屏加载动画
      editShow: false, // 是否显示编辑框
      cardRecord: false, // 是否显示编辑框
      detailShow: false, // 是否显示编辑框
      syncRecordShow: false, // 是否显示同步记录框
      filename: 'cardInfoTemp.xlsx',
      deptShowTop: false, // 是否显示顶级
      wellShow: false
    }
  },
  mounted() {
    // this.fetchDeviceType()// 获取设备类别
    if (this.$route.query.devType !== null && this.$route.query.devType !== '') {
      this.listQuery.devType = this.$route.query.devType // 接收路由参数
    }
    this.fetchData()// 获取数据
  },
  methods: {
    // 检查选择情况
    checkSelection() {
      if (this.multipleSelection.length === 0) {
        return false
      } else {
        return true
      }
    },
    // 批量导入
    uploadFile(param) {
      // 判断文件大小是否符合要求
      const _file = param.file
      const isLt5M = _file.size / 1024 / 1024 < 5
      if (!isLt5M) {
        this.$message.error('请上传5M以下的excel文件')
        return false
      }
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '导入中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      // 发起导入请求
      batchImportCard(_file).then(res => {
        loading.close() // 关闭加载动画
        if (res.code === 200) {
          this.$message.success('导入成功')
          this.fileList = []
          this.fetchData(false)
        }
      }).catch(() => {
        loading.close()
      })
      this.fileList = []
    },
    // 批量导出
    batchExport() {
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '数据处理中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      batchExportCard(this.listQuery).then(res => {
        loading.close() // 关闭加载动画
        downloadFile(res.data, '卡片列表')
      }).catch((res) => {
        loading.close()
      })
    },
    // 新增设备
    add() {
      this.dialogFormVisible = true
      this.editShow = true
      this.$refs.editcard.initDialog('create', this.dialogFormVisible)
    },
    // 编辑设备信息
    edit(row) {
      this.dialogFormVisible = true
      this.editShow = true
      this.$refs.editcard.initDialog('update', this.dialogFormVisible, row)
    },
    log(row) {
      this.cardRecord = true
      this.$refs.cardrecord.initDialog(row.cardCode)
    },
    // 删除设备
    del() {
      if (this.checkSelection()) {
        const cardIds = []
        this.multipleSelection.forEach(function(value, index) {
          cardIds.push(value.id)
        })
        console.log(cardIds)
        // wellNames = wellNames.slice(0, wellNames.length - 1)
        this.$confirm(
          '确定要删除所选设备吗？',
          '确认操作',
          {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }
        ).then(() => {
          delCard(cardIds).then(response => {
            if (response.code === 200) {
              this.$message.success('删除成功')
              this.fetchData()
            }
          })
        })
      } else {
        this.$message.error('至少选中一项')
      }
    },
    // 查询数据
    search() {
      this.fetchData(false)
    },
    // 获取设备列表
    fetchData(isNowPage = true) {
      this.listLoading = true
      if (!isNowPage) { // 是否显示当前页，否则跳转第一页
        this.listQuery.offset = 1
      }
      getCardList(this.listQuery).then(response => {
        this.list = response.data.rows
        this.total = parseInt(response.data.total)
        this.listLoading = false
      })
    },
    showWellDetail(row) {
      this.wellShow = true
      this.$refs.wellInfo.initDialog(row.wellId)
    },
    indexMethod(index) {
      return this.listQuery.limit * (this.listQuery.offset - 1) + index + 1
    },
    // 改变页容量
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.fetchData()
    },
    // 改变当前页
    handleCurrentChange(val) {
      this.listQuery.offset = val
      this.fetchData()
    },
    // 多选触发方法
    handleSelectionChange(val) {
      this.multipleSelection = val
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  $tableTitleHeight:46px;
  .table{
    margin-bottom: 20px;
  }
  .pagination-container{
    margin-bottom: 50px;
  }
  .table-title{
    background-color:rgba(243, 243, 243, 1);
    height: $tableTitleHeight;
    .title-header{
      line-height:$tableTitleHeight;
      color: #606266;
      font-size: 15px;
      i{
        margin-left: 5px;
        margin-right: 5px;
      }
    }
  }
  .edit_btns{
    .edit_btn{
      float:right;
      margin:7px 3px;//为了需要居中显示margin-top和bottom要用$tableTitleHeight减去按钮原高度除以2
    }
  }
</style>
